// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvTreeNodes.pas' rev: 6.00

#ifndef AdvTreeNodesHPP
#define AdvTreeNodesHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ImgList.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Advtreenodes
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TDbgList;
class DELPHICLASS TAdvTreeNode;
class PASCALIMPLEMENTATION TDbgList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	TAdvTreeNode* operator[](int Index) { return Items[Index]; }
	
private:
	TAdvTreeNode* __fastcall GetItemsEx(int Index);
	void __fastcall SetItemsEx(int Index, const TAdvTreeNode* Value);
	
public:
	void __fastcall AssignList(Classes::TList* ListA);
	__property TAdvTreeNode* Items[int Index] = {read=GetItemsEx, write=SetItemsEx/*, default*/};
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TDbgList(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TDbgList(void) : Classes::TList() { }
	#pragma option pop
	
};


#pragma option push -b-
enum TNodeType { ntText, ntCheckbox, ntRadioButton };
#pragma option pop

struct TNodeInfo;
typedef TNodeInfo *PNodeInfo;

#pragma pack(push, 1)
struct TNodeInfo
{
	int SelectedIndex;
	int StateIndex;
	int OverlayIndex;
	void *Data;
	int Count;
	System::SmallString<255>  Text;
	TNodeType NodeType;
	bool Checked;
	System::SmallString<255>  ImageURL;
	System::SmallString<255>  ImageCollapsedURL;
	System::SmallString<255>  URL;
	int Tag;
	System::SmallString<255>  Hint;
	bool IsExpanded;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TNodeDataInfo
{
	int SelectedIndex;
	int StateIndex;
	int OverlayIndex;
	void *Data;
	int Count;
	TNodeType NodeType;
	bool Checked;
	int Tag;
	bool IsExpanded;
	Byte TextLen;
	Byte HintLen;
	Byte URLLen;
	Byte ImageURLLen;
	Byte ImageCollapsedURLLen;
} ;
#pragma pack(pop)

typedef TMetaClass*TAdvTreeNodeClass;

class DELPHICLASS TAdvTreeNodes;
class PASCALIMPLEMENTATION TAdvTreeNodes : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
public:
	TAdvTreeNode* operator[](int Index) { return Item[Index]; }
	
private:
	Classes::TComponent* FOwner;
	TAdvTreeNode* FFirstNode;
	TDbgList* FNodeList;
	bool FDeleting;
	bool FReading;
	Classes::TNotifyEvent FOnChange;
	TAdvTreeNode* __fastcall GetNodeFromIndex(int Index);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	void __fastcall SetItem(int Index, TAdvTreeNode* Value);
	int __fastcall GetCount(void);
	TAdvTreeNode* __fastcall InsertNode(TAdvTreeNode* ParentNode, TAdvTreeNode* DesNode, bool InsertBefore);
	bool __fastcall IsVeryFirstNode(TAdvTreeNode* Node);
	TAdvTreeNode* __fastcall CreateNode(void);
	__property bool Reading = {read=FReading, nodefault};
	
public:
	__fastcall TAdvTreeNodes(Classes::TComponent* AOwner);
	__fastcall virtual ~TAdvTreeNodes(void);
	TAdvTreeNode* __fastcall AddFirst(const AnsiString S)/* overload */;
	TAdvTreeNode* __fastcall AddFirst(System::TObject* Data, const AnsiString S)/* overload */;
	TAdvTreeNode* __fastcall Add(const AnsiString S)/* overload */;
	TAdvTreeNode* __fastcall Add(System::TObject* Data, const AnsiString S)/* overload */;
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Clear(void);
	void __fastcall Delete(TAdvTreeNode* Node);
	TAdvTreeNode* __fastcall GetFirstNode(void);
	TAdvTreeNode* __fastcall GetLastNode(void);
	TAdvTreeNode* __fastcall Insert(TAdvTreeNode* Sibling, const AnsiString S);
	TAdvTreeNode* __fastcall InsertObject(TAdvTreeNode* Sibling, const AnsiString S, System::TObject* Data);
	__property int Count = {read=GetCount, nodefault};
	__property TAdvTreeNode* Item[int Index] = {read=GetNodeFromIndex/*, default*/};
	__property Classes::TComponent* Owner = {read=FOwner};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	void __fastcall Changed(void);
};


class PASCALIMPLEMENTATION TAdvTreeNode : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
public:
	TAdvTreeNode* operator[](int Index) { return Item[Index]; }
	
private:
	TAdvTreeNodes* FOwner;
	AnsiString FText;
	System::TObject* FData;
	Imglist::TImageIndex FImageIndex;
	bool FDeleting;
	bool FIsExpanded;
	TAdvTreeNode* FFirstChild;
	TAdvTreeNode* FNextSibling;
	TAdvTreeNode* FPrevSibling;
	TAdvTreeNode* FParentNode;
	bool FShowText;
	AnsiString FImageCollapsedURL;
	AnsiString FImageURL;
	TNodeType FNodeType;
	AnsiString FURL;
	bool FChecked;
	int FTag;
	AnsiString FHint;
	int __fastcall GetLevel(void);
	TAdvTreeNode* __fastcall GetParent(void);
	int __fastcall GetIndex(void);
	TAdvTreeNode* __fastcall GetItem(int Index);
	int __fastcall GetCount(void);
	bool __fastcall IsEqual(TAdvTreeNode* Node);
	void __fastcall SetData(System::TObject* Value);
	void __fastcall SetItem(int Index, TAdvTreeNode* Value);
	void __fastcall SetText(const AnsiString S);
	bool __fastcall GetHasChildren(void);
	void __fastcall SetShowText(const bool Value);
	void __fastcall ReadData(Classes::TStream* Stream, TNodeDataInfo &Info);
	void __fastcall WriteData(Classes::TStream* Stream, TNodeDataInfo &Info);
	void __fastcall SetChecked(const bool Value);
	void __fastcall SetImageCollapsedURL(const AnsiString Value);
	void __fastcall SetImageURL(const AnsiString Value);
	void __fastcall SetNodeType(const TNodeType Value);
	void __fastcall SetURL(const AnsiString Value);
	void __fastcall SetTag(const int Value);
	void __fastcall SetHint(const AnsiString Value);
	
protected:
	bool __fastcall CompareCount(int CompareMe);
	__property TAdvTreeNodes* Owner = {read=FOwner};
	
public:
	__property TAdvTreeNode* Item[int Index] = {read=GetItem, write=SetItem/*, default*/};
	int __fastcall IndexOf(TAdvTreeNode* Value);
	__property int Count = {read=GetCount, nodefault};
	__property int Index = {read=GetIndex, nodefault};
	__fastcall TAdvTreeNode(TAdvTreeNodes* AOwner);
	__fastcall virtual ~TAdvTreeNode(void);
	TAdvTreeNode* __fastcall AddFirstChild(const AnsiString S)/* overload */;
	TAdvTreeNode* __fastcall AddFirstChild(System::TObject* Data, const AnsiString S)/* overload */;
	TAdvTreeNode* __fastcall AddChild(const AnsiString S)/* overload */;
	TAdvTreeNode* __fastcall AddChild(System::TObject* Data, const AnsiString S)/* overload */;
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Delete(void);
	void __fastcall DeleteChildren(void);
	TAdvTreeNode* __fastcall getFirstChild(void);
	TAdvTreeNode* __fastcall GetLastChild(void);
	TAdvTreeNode* __fastcall GetNextChild(TAdvTreeNode* Value);
	TAdvTreeNode* __fastcall getNextSibling(void);
	TAdvTreeNode* __fastcall GetPrevChild(TAdvTreeNode* Value);
	TAdvTreeNode* __fastcall getPrevSibling(void);
	bool __fastcall HasAsParent(TAdvTreeNode* Value);
	bool __fastcall IsFirstNode(void);
	bool __fastcall IsFirstChild(void);
	__property bool Deleting = {read=FDeleting, nodefault};
	__property bool IsExpanded = {read=FIsExpanded, write=FIsExpanded, nodefault};
	__property bool HasChildren = {read=GetHasChildren, nodefault};
	__property int Level = {read=GetLevel, nodefault};
	__property TAdvTreeNode* Parent = {read=GetParent};
	__property AnsiString Text = {read=FText, write=SetText};
	__property System::TObject* Data = {read=FData, write=SetData};
	__property bool ShowText = {read=FShowText, write=SetShowText, default=1};
	__property TNodeType NodeType = {read=FNodeType, write=SetNodeType, default=0};
	__property bool Checked = {read=FChecked, write=SetChecked, default=0};
	__property AnsiString URL = {read=FURL, write=SetURL};
	__property AnsiString ImageCollapsedURL = {read=FImageCollapsedURL, write=SetImageCollapsedURL};
	__property AnsiString ImageURL = {read=FImageURL, write=SetImageURL};
	__property int Tag = {read=FTag, write=SetTag, default=0};
	__property AnsiString Hint = {read=FHint, write=SetHint};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Advtreenodes */
using namespace Advtreenodes;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdvTreeNodes
